#ifndef _CLI_PARAM_H_
#define _CLI_PARAM_H_

#include <ast/Ast.h>
#include <abstraction/OperationAbstraction.hpp>
#include <environment/Environment.h>

namespace cli {

class Param {
public:
	virtual ~Param ( ) noexcept {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > & prev, Environment & environment ) const = 0;

	virtual bool getImplicitMove ( ) const = 0;
};

} /* namespace cli */

#endif /* _CLI_PARAM_H_ */
